import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;


public class Bank {
	public   static final int CREDIT=-5000;
	private List<Account> accountList;
	private static int accountNum=1000;
	public Bank()
	{
		this.accountList = new List<Account>();
	}
	
	public int openAccount (String ownerName)
	{
		Account a=new Account(accountNum ,ownerName , 0);
		accountNum++;
		Node<Account> n =this.accountList .getFirst() ;
		//Node<Account> beforeN=null;
		while(n !=null)
		{
			//beforeN=n;
			n=n.getNext() ;
		}
		this.accountList .insert( n,a);
		return a.getAccountNum() ;
	}
	public  void deposit (int accountNum, double amount)
	{
		Node<Account> n =this.accountList .getFirst() ;
		boolean flag=false;
		while(n!=null&& flag==false)
		{
			if(accountNum==n.getInfo() .getAccountNum() )
			{
				n.getInfo() .setAmount( n.getInfo() .getAmount() +amount);
				flag=true;
			}
			n=n.getNext() ;
		}
	}
	public boolean withdrawal (int accountNum,  double amount)
	{
		Node<Account> n =this.accountList .getFirst() ;
		boolean flag=false;
		while(n!=null&& flag==false)
		{
			if(accountNum==n.getInfo() .getAccountNum() )
			{
				if(n.getInfo().getAmount()- amount>CREDIT)
				{
					n.getInfo() .setAmount( n.getInfo() .getAmount() -amount);
					flag=true;
				}
				
			}
			n=n.getNext() ;
		}
		return false;
	}
	public double getBalance (int accountNum)
	{
		Node<Account> n =this.accountList .getFirst() ;
		
		while(n!=null)
		{
			if(accountNum==n.getInfo() .getAccountNum() )
			{
				return n.getInfo() .getAmount() ;
				
			}
			n=n.getNext() ;
		}
		return 0;
	}
	
	public String getOwnerName (int accountNum)
	{
		Node<Account> n =this.accountList .getFirst() ;
		
		while(n!=null)
		{
			if(accountNum==n.getInfo() .getAccountNum() )
			{
				return n.getInfo().getOwnerName()  ;
				
			}
			n=n.getNext() ;
		}
		return "";
	}
	public boolean accountExist (int accountNum)
	{
		Node<Account> n =this.accountList .getFirst() ;
		
		while(n!=null)
		{
			if(accountNum==n.getInfo() .getAccountNum() )
			{
				return true  ;
				
			}
			n=n.getNext() ;
		}
		return false;
	}
	public List<Integer> getAllAccountsNums()
	{
		List<Integer> listAccount=new List<Integer>();
		Node<Account> n =this.accountList .getFirst() ;
		Node <Integer> pos=listAccount.getFirst() ;
		while(n!=null)
		{
			pos=listAccount.insert( pos,n.getInfo() .getAccountNum() );
			n=n.getNext() ;
		}
		return listAccount;
	}
	
	public int[] getAllAccountsOf (String name)
	{
		Node<Account> n =this.accountList .getFirst() ;
		int mone=0;
		while(n!=null)
		{
			if (name.compareTo( n.getInfo().getOwnerName())==0)
				mone++;
				
			n=n.getNext() ;
		}
		int[] accounts=new int[mone];
		
		 n =this.accountList .getFirst() ;
		int i=0;
		while(n!=null)
		{
			if (name.compareTo( n.getInfo().getOwnerName())==0)
				accounts[i]=n.getInfo().getAccountNum();
			i++;
				
			n=n.getNext() ;
		}
		
		return accounts;
	}
	public String toString()
	{
		String str="";
		Node<Account> n =this.accountList .getFirst() ;
		
		while(n!=null)
		{
			str+=n.toString()+"\n"; 
			n=n.getNext() ;
		}
		return str;
	}
}
